// PwrExample.cpp : Defines the entry point for the console application.
//MC-1100 module power reset

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>
#include "mxgpio.h"


#define MAX_SOCKET_NUMBER 1
#define PWR_INDEX	 0
#define PWR_OFF	 0
#define PWR_ON	 1

int _tmain(int argc, _TCHAR* argv[])
{
	HANDLE	hMxPWR;
	int port_no=0;
	int	nLED = 0;
	int port = 0,mode = 0;
	int n = 0;
	int on = 1;
	int data=0;
	int	input=0,output=0;

	WCHAR sin,smode;
	printf("Mini PCIE Power Contol Test Program\n");
	printf("\t (0) Exit Program\n");
    printf("\t (1) Display Power condition\n");
    printf("\t (2) Set Power on/off \n");

	sin=getwchar();
	n=_wtoi(&sin);

	do
    {
        switch (n)
        {
			case 1:
				//Open power control
				hMxPWR=mxgpio_open();

				for(int i = 0; i < MAX_SOCKET_NUMBER; i++)
				{
					//Get power status
					input=mxgpio_get_data(hMxPWR, PWR_INDEX + i);
					if( input == PWR_OFF){
						printf("Socket%d is off\n",i+1);
					}else if( input == PWR_ON){
						printf("Socket%d is on\n",i+1);
					}
				}
				//Close power control
                mxgpio_close(hMxPWR);
                break;

			case 2:
				//Get Port Number
				
				if(MAX_SOCKET_NUMBER>1){
					getwchar();
					printf("Input the Socket Number (1 ~ %d) = \n",MAX_SOCKET_NUMBER);
					smode = getwchar();
				}else if(MAX_SOCKET_NUMBER==1){
					smode ='1';
				}else{
					getwchar();
					printf("MAX_SOCKET_NUMBER must larger or equal 1\n");
					break;
				}
				port_no = _wtoi(&smode)-1 + PWR_INDEX;
				
				if( (_wtoi(&smode) >(MAX_SOCKET_NUMBER)) || (_wtoi(&smode) < 1) ){
					printf("The port value you input must betwwen 1 ~ %d ",MAX_SOCKET_NUMBER);
					break;
				}

				//Get Value
                getwchar();
                printf("Input 0 or 1 (0 = Off, 1 = On) = ");
				smode = getwchar();
				data = _wtoi(&smode);
		
				if( (data!=0) && (data!=1) ){
					printf("The value you input must be 0 or 1. ");
					break;
				}

				//Open power control
				hMxPWR = mxgpio_open();

				//Set power control
				output = mxgpio_set_data(hMxPWR, port_no, data);
				
				if(output==-1)
				{
					printf("Set Power fail!\n");
				}
				else
				{
					printf("Set Power success!\n");
				}

				//Close LED
				mxgpio_close(hMxPWR);
                
				
				break;
		}
		getwchar();
		printf("\n");
		printf("Mini PCIE Power Contol Test Program\n");
		printf("\t (0) Exit Program\n");
		printf("\t (1) Display Power condition\n");
		printf("\t (2) Set Power on/off \n");
        sin = getwchar();
        n = _wtoi(&sin);
    } while (n != 0);

	return 0;
}
